////////////////////////////////////////////////////////////////////////////////////
//////CODI PROGRAMA  WASPMOTE PAX///////////////////////////////////////////
////Created By Rubén Almansa for EXIT Research group//////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
#include <WaspXBeeZB.h>
#include <WaspFrame.h>
#include <WaspFrameConstants.h>
#define Se  6    //pin sensor
#define Sd  8    // pin sensor
#define polsador 10
#define indicador 13
///// ////// Adreça Meshlium/////////////////////
char RX_ADDRESS[] = "0013A200408134BA"; 
///////////////////////////////////////////////

/////////// DEFINICIÓ VARIABLES COMUNS///////////////
uint8_t error,error2;
char* macHigh="          ";
char* macLow="           "; 
timestamp_t time;  // guarda el timestsamp del Meshlium
unsigned long epoch; // fa un break del timestamp i ho guarda en aquesta variable
int Tx; // resgistre el flag del frame enviat.
int noSend=0; //comptador d'enviaments erronis
int errorRTC=0; //registre el flag de la RTC ok.
int SumErrorRTC=0; // comptador d'errors de la  sincronització deRTC
////////////////////////////////////////////////

////////////VARIABLES PAX////////////////
int e=0,d=0,tim=0; // entrades i timers a 0
int sum =0,res=0; // suma o resta
int tot=0; // total de persones
char i; //estat de la maquina d'estats
int a=1025; // registre eeprom
int ad=0; // index de l'adreça eeprom
int b=0;
int medPax; //calcul per la mitjana persones
int c=0;
int f;
float medPaxSum,deco; // registres interns per calcular les pax
int medPaxSumi; // mitjana total que s'envia
int bat; // bateria
int LDR=0;
int RST=0;
int reset=0;

////////////////////////////////////////////////
///////////*PROGRAMA D'INICI*///////
void setup()
{
/*ACTIVA la RTC i el port USB*/

  RTC.ON();
  delay(2000);
  USB.ON();
  delay(200);

  
  PWR.setSensorPower(SENS_5V,SENS_ON);// dona tensió als pins per alimentar la placa
  pinMode(DIGITAL6,INPUT);
  pinMode(DIGITAL8,INPUT);
  PWR.setWatchdog(WTD_ON,WTD_1S); // configura el watchdog a un segon
  i='Q';
  USB.println("START");
  
  IniXBee();   
  checkNetworkParams();
  ResetNetwork();
  RTCMeshlium();
 
}

////////////////////////////////////////
///////////*PROGRAMA PRINCIPAL*/////////

void loop()
{

 USB.println(RTC.getTime());
 epoch=RTC.getEpochTime(); // guarda el time en un format, és necessari per la comanda següent
 RTC.breakTimeAbsolute( epoch, &time); // trenca el timestamp per obtenir el minut que estem
 
/* llegeig les entrades constanmet dels sensors IR*/ 
d=digitalRead(DIGITAL8);
delay(10);

e=digitalRead(DIGITAL6);
delay(10);

/* Aquest if serveix per activar el temps en cas que una persona intenta sortir però no ho fa*/
if (reset==1 && d==LOW && e==LOW){PWR.setWatchdog(WTD_ON,WTD_1S);}

if (intFlag & WTD_INT && reset>10)
{
  reset=0;
  USB.println("WDT");
  USB.println(tot);
  intFlag &= ~(WTD_INT);
  tim=1; // vol dir que el timer WTD s'ha activat
  }

////AQUI COMENÇA LA MAQUINA D'ESTATS PER COMPTAR PERSONES////////
  
    // estat de repós o inicial
     switch (i) {
      case 'Q': //USB.println("Q");
        tim=0;
        if(d==LOW && e==LOW ||d==HIGH && e==HIGH ){i='Q';} 
        if(e==HIGH&&d==LOW){i='W';}  //entrar
        if(d==HIGH&&e==LOW){i='T';}  // sortir
        
      break;
     
     
     // estat on hi ha detecció sensor entrada de la primera persona
      case 'W': 
          USB.println("w");
          if(d==LOW && e==LOW ){reset=reset+1;} // si algú ha però al final no entra, el reset relentitza el temps per tornar a 0
          if(d==HIGH && e==LOW){i='E';}
          if(d==LOW && e==HIGH){i='W';reset=0;intFlag &= ~(WTD_INT);} // passa al següent sensor
          if(d==HIGH && e==HIGH){i='E';}
          if(tim==1){i='Q';tim=0;} // si WTD s'ha activat torna a la pos Ini
     
       break;
     // detecta el segon sensor IR
     case 'E':
          reset=0;
          intFlag &= ~(WTD_INT);
          USB.println("E");
          if(d==LOW && e==HIGH ){i='W';} 
          if(d==LOW && e==LOW ){i='R';} 
          if(d==HIGH && e==LOW){i='E';}
          if(d==HIGH && e==HIGH){i='E';}
       break;
       
       // ha fet la seqüència d'entrada i comptabilitza una persona
       case 'R':
       //USB.println("R");
          sum=sum+1; // suma una persona
          i='Q';
          tim=0;
          tot=sum-res; // calcula numero total de persones
          USB.println(tot);
          Utils.writeEEPROM(a,tot);
          a=a+1; // suma una posició de eeprom
          b=b+1; // compta el numero de deteccions completes

       break;

// es el mateix procés que l'anterior però per sortir
     case 'T': 
          USB.println("T");
          if(d==LOW && e==LOW){reset=reset+1;} 
          if(d==LOW && e==HIGH){i='Y';}
          if(d==HIGH && e==LOW){i='T';reset=0;intFlag &= ~(WTD_INT);}
          if(d==HIGH && e==HIGH){i='Y';}
          if(tim==1){i='Q';tim=0;} 
     
       break;

     case 'Y':
           reset=0;
           intFlag &= ~(WTD_INT);
           USB.println("Y");
          if(d==HIGH && e==LOW ){i='T';} 
          if(d==LOW && e==LOW ){i='U';} 
          if(d==LOW && e==HIGH){i='Y';}
          if(d==HIGH && e==HIGH){i='Y';}
       break;
       
       case 'U':
       //USB.println("U");
          res=res+1; 
          i='Q';
          tot=sum-res;
          Utils.writeEEPROM(a,tot);
          a=a+1;
          b=b+1;
          USB.println(tot);

       break;}
///////////////////////////////////////////
///Comprovem la hora  amb aquest if///////////
  if( ((time.minute == 00) || (time.minute == 10)||(time.minute == 20)||(time.minute == 30) || (time.minute == 40)||(time.minute == 50))&& Tx==0)

  {
    bat=PWR.getBatteryLevel();
    ad=1025;/////s'ha de canviar
    f=1;
    medPax=0;
    // suma tots els registres de la eeprom per fer la mitjana
    while(f<=b){
      medPax=(Utils.readEEPROM(ad));
      USB.println(medPax);
      medPaxSum=medPax+medPaxSum;
      ad=ad+1;
      f=f+1;
      }
      // fa la mitjana
     medPaxSum=medPaxSum/b;
     medPaxSumi=medPaxSum;
     deco=medPaxSum-medPaxSumi;
     if(deco>0.5){medPaxSumi=medPaxSumi+1;} // fem aproximació de gent
     USB.println(medPaxSum);
     USB.println(medPaxSumi);
     //if(medPaxSumi<0){medPaxSumi=0;}
     //if(medPaxSumi>14){medPaxSumi=14;}
    medPaxSum=0;
    LDR=analogRead(ANALOG3); // llegeix el valor per saber si es fosc i resetjar el valor pax
    LDR=(LDR*5)/1024;
    USB.println(LDR);
    delay(100);
    a=1025; // a és adreça de EEPROM
    b=1; // b és el número de vegades que ha entrat o sortit persones b=1 quan hi ha gent b=0 quan ha marxat tothom
    if(tot<=0){tot=0;medPaxSumi=0;}
    Utils.writeEEPROM(a,tot); 
    a=a+1;
    sum=tot; // la suma passa a ser el total
    res=0;
    EnviarDades(); // envia les dades
    USB.println(LDR);
    if(LDR>1){RST=0;} // guarda variable RST per resetejar el sistema una vegada
    // el ssitema torna a 0 pax
    if((LDR<1 && RST==0)&& (time.hour == 01)){sum = 0; res=0; tot=0; a=1025; b=0; RST=1;PWR.reboot();}
    // alarma per resetejar la variable de TX passat una estona
    RTC.setAlarm1("00:00:08:00",RTC_OFFSET,RTC_ALM1_MODE4);
  }
   if ( intFlag & RTC_INT ) {   
    intFlag &= ~(RTC_INT);
    RTC.clearAlarmFlag();
    delay(1000);
    Tx=0;  
  }

}


/////////////////////////////////////////////////////////
///////*AQUESTA FUNCIÓ S'ENCARREGA D'ENVIAR LES DADES*///////////

void EnviarDades(){

  while(Tx==0){
   
   frame.setID( macLow ); // és el identificador del WASPMOTE
   frame.createFrame(ASCII); // indicador per iniciar el frame. 
  //s'afegeix les variables de cada waspmote que s'enviaràn
  frame.addSensor(SENSOR_STR, medPaxSumi,tot,bat);
  delay(100);
  // envia el paquet
  error = xbeeZB.send( RX_ADDRESS, frame.buffer, frame.length );   
  if( error == 0 ) // comprova l'enviament
  
  {
    USB.println(F("send ok"));
    
    // blink green LED
    Utils.blinkGreenLED();
     noSend=0;
    Tx=1; // Variable per comfirmar qu l'envio ha estat correcte  
    delay(60000);
  }
  else 
  {
    USB.println(F("send error"));
    
     if (noSend>10){PWR.reboot();}
       noSend=noSend+1;
  }
}
}

/////////////////////////////////////////////////////////

///////* FUNCIÓ QUE CONNECTA AMB MESHLIUM PER OBTENIR EL TIMESTAMP*/////////////

void RTCMeshlium()

{
  while (errorRTC ==0){
   error2 = xbeeZB.setRTCfromMeshlium(RX_ADDRESS);
    // check flag si la RTC s'ha sincronitzat
  if( error2 == 0 )
  {
    USB.print(F("SET RTC ok. "));
    errorRTC=1;
    USB.println(RTC.getTime());
    }
  else 
  {
    USB.print(F("SET RTC error. "));
    errorRTC=0;
    SumErrorRTC=SumErrorRTC+1;
    if (SumErrorRTC>10){PWR.reboot();} // si es produeixen molts errors reseteja el sistema.
    }
}
} 
/////////////////////////////////////////////////////////////////////
//////FUNCIÓ ENCARREGADA D'INICIAR ELS XBEE I OBTENIR LA MAC*////////

void IniXBee()

{
  xbeeZB.ON();
  delay(3000);
  xbeeZB.getOwnMacLow(); // obté la MAC LOW
  xbeeZB.getOwnMacHigh(); // obté la MAC HIGH
  // Guarda les MAC
  Utils.hex2str(xbeeZB.sourceMacHigh,macHigh,4); 
  Utils.hex2str(xbeeZB.sourceMacLow,macLow,4);
} 
  
////////////////////////////////////////////////////////////  
//////*COMPROVA ELS PARAMETRES DE LA XARXA XBEE*///////////  
void checkNetworkParams()
{
  // Obté la identificació de xarxa
  xbeeZB.getOperating64PAN();

  //  comprova la associació amb meshlium
  xbeeZB.getAssociationIndication();
 
  while( xbeeZB.associationIndication != 0 )
  { 
    delay(2000);
    
    
    xbeeZB.getOperating64PAN();

    USB.print(F("operating 64-b PAN ID: "));
    USB.printHex(xbeeZB.operating64PAN[0]);
    USB.printHex(xbeeZB.operating64PAN[1]);
    USB.printHex(xbeeZB.operating64PAN[2]);
    USB.printHex(xbeeZB.operating64PAN[3]);
    USB.printHex(xbeeZB.operating64PAN[4]);
    USB.printHex(xbeeZB.operating64PAN[5]);
    USB.printHex(xbeeZB.operating64PAN[6]);
    USB.printHex(xbeeZB.operating64PAN[7]);
    USB.println();     
    
    xbeeZB.getAssociationIndication();
  }

  USB.println(F("\nJoined a network!"));

  
  xbeeZB.getOperating16PAN();
  xbeeZB.getOperating64PAN();
  xbeeZB.getChannel();

  USB.print(F("operating 16-b PAN ID: "));
  USB.printHex(xbeeZB.operating16PAN[0]);
  USB.printHex(xbeeZB.operating16PAN[1]);
  USB.println();

  USB.print(F("operating 64-b PAN ID: "));
  USB.printHex(xbeeZB.operating64PAN[0]);
  USB.printHex(xbeeZB.operating64PAN[1]);
  USB.printHex(xbeeZB.operating64PAN[2]);
  USB.printHex(xbeeZB.operating64PAN[3]);
  USB.printHex(xbeeZB.operating64PAN[4]);
  USB.printHex(xbeeZB.operating64PAN[5]);
  USB.printHex(xbeeZB.operating64PAN[6]);
  USB.printHex(xbeeZB.operating64PAN[7]);
  USB.println();

  USB.print(F("channel: "));
  USB.printHex(xbeeZB.channel);
  USB.println();

}
/////////////////////////////////////////////////////////
/////////*RESETEJA ELS PAREMETRES DE LA XARXA*//////////

void  ResetNetwork(){
  
   while((xbeeZB.channel) !=0x10){
    xbeeZB.OFF();
    delay(1000);
    xbeeZB.ON();
    delay(3000);
    xbeeZB.resetNetwork(0); // reseteja els paràmetres de la xarxa
    delay(1000);
    checkNetworkParams(); // comprova aquests paràmetres.
  }
}

