////////////////////////////////////////////////////////////////////////////////////
//////CODI PROGRAMA  WASPMOTE CONSUM GENERAL///////////////////////////////////////////
////Created By Rubén Almansa for EXIT Research group//////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

#include <WaspXBeeZB.h>
#include <WaspFrame.h>
#include <WaspFrameConstants.h>
// es defineixen els factors de potència per a cada fase
#define cosFi1 0.80 
#define cosFi2 0.72
#define cosFi3 0.75
#define V 232 // voltatge constant per cada fase
///// ////// Adreça Meshlium/////////////////////
char RX_ADDRESS[] = "0013A200408134BA"; 
///////////////////////////////////////////////

/////////// DEFINICIÓ VARIABLES COMUNS///////////////
uint8_t error,error2;
char* macHigh="          ";
char* macLow="           "; 
timestamp_t time;  // guarda el timestsamp del Meshlium
unsigned long epoch; // fa un break del timestamp i ho guarda en aquesta variable
int Tx; // resgistre el flag del frame enviat.
int noSend=0; //comptador d'enviaments erronis
int errorRTC=0; //registre el flag de la RTC ok.
int SumErrorRTC=0; // comptador d'errors de la  sincronització deRTC
////////////////////////////////////////////////

////////////VARIABLES CONSUM////////////////
int bat;
float Imig1,Imig2,Imig3; // la mitjana del corrent
float val,val2,val3,valt,val2t,val3t; // calcula valors parcials i totals
float P1,P2,P3; //  potències cada fase
float C1,C2,C3,CT; // consums
float CTS;// suma del conum total
float h; // temps en hores dels 10 minuts
int i=0;// numero de mostres
////////////////////////////////////////////////
///////////*PROGRAMA D'INICI*///////
void setup()
{
/*ACTIVA la RTC i el port USB*/

  RTC.ON();
  delay(2000);
  USB.ON();
  delay(200);
 
 // Activa l'alimentació a les plaques de consum
  PWR.setSensorPower(SENS_5V,SENS_ON);
  
  IniXBee();   
  checkNetworkParams();
  ResetNetwork();
  RTCMeshlium();
 
}

////////////////////////////////////////
///////////*PROGRAMA PRINCIPAL*/////////

void loop()
{

 USB.println(RTC.getTime());
 LlegirConsum();
 epoch=RTC.getEpochTime(); // guarda el time en un format, és necessari per la comanda següent
 RTC.breakTimeAbsolute( epoch, &time); // trenca el timestamp per obtenir el minut que estem
 
 //Aquest "if" s'encarrega de comprovar el minut d'enviament i a continuació proscessa el càlcul
 if(((time.minute == 00) || (time.minute == 10)||(time.minute == 20)||(time.minute == 30) || (time.minute == 40)||(time.minute == 50))&&Tx==0){
  
    bat=PWR.getBatteryLevel();
    h=0.16;
    USB.println(h);
    
    
   Imig1=valt/i;   
   P1=V*Imig1*cosFi1;
   C1=P1*h;
   USB.println(Imig1);
   USB.println(P1);
   USB.println(C2);
   
   
   Imig2=val2t/i;
   USB.println(Imig2);
   P2=V*Imig2*cosFi2;
   USB.println(P2);
   C2=P2*h;
   USB.println(C2);

   
   Imig3=val3t/i;
   USB.println(Imig3);
   P3=V*Imig3*cosFi3;
   USB.println(P3);
   C3=P3*h;
   USB.println(C3);
   
    CTS=C1+C2+C3;
    USB.println(CTS);
  
   
   EnviarDades();
   i=0;
   valt=0;
   val2t=0;
   val3t=0;
  PWR.reboot();
  }
}


/////////////////////////////////////////////////////////
/*FUNCIÓ QUE LLEGEIX LES DADES RESTANTS AL SO */

void LlegirConsum()
{  
  USB.print("Value read from Analog 1: ");
  val=analogRead(ANALOG1);
  delay(100);
  val=val*3.3/1024;
  USB.println(val);
  valt=val+valt;// acumula el valor de consum
  
  USB.print("Value read from Analog 2: ");
  val2=analogRead(ANALOG3);
  delay(100);
  val2=val2*3.3/1024;
  USB.println(val2);
  val2t=val2t+val2;// acumula el valor de consum
  
  USB.print("Value read from Analog 3: ");
  val3=analogRead(ANALOG5);
  delay(100);
  val3=val3*3.3/1024;
  USB.println(val3);
  val3t=val3t+val3; // acumula el valor de consum
delay(700);
i=i+1; // numero de mostres que s'agafen duran els 10 minuts
  
}


/////////////////////////////////////////////////////////
///////*AQUESTA FUNCIÓ S'ENCARREGA D'ENVIAR LES DADES*///////////

void EnviarDades(){

  while(Tx==0){
   
   frame.setID( macLow ); // és el identificador del WASPMOTE
   frame.createFrame(ASCII); // indicador per iniciar el frame. 
  //s'afegeix les variables de cada waspmote que s'enviaràn
  frame.addSensor(SENSOR_STR, CTS,bat);
  delay(100);
  // envia el paquet
  error = xbeeZB.send( RX_ADDRESS, frame.buffer, frame.length );   
  if( error == 0 ) // comprova l'enviament
  
  {
    USB.println(F("send ok"));
    
    // blink green LED
    Utils.blinkGreenLED();
     noSend=0;
    Tx=1; // Variable per comfirmar qu l'envio ha estat correcte  
    delay(60000);
  }
  else 
  {
    USB.println(F("send error"));
    
     if (noSend>10){PWR.reboot();}
       noSend=noSend+1;
  }
}
}

/////////////////////////////////////////////////////////

///////* FUNCIÓ QUE CONNECTA AMB MESHLIUM PER OBTENIR EL TIMESTAMP*/////////////

void RTCMeshlium()

{
  while (errorRTC ==0){
   error2 = xbeeZB.setRTCfromMeshlium(RX_ADDRESS);
    // check flag si la RTC s'ha sincronitzat
  if( error2 == 0 )
  {
    USB.print(F("SET RTC ok. "));
    errorRTC=1;
    USB.println(RTC.getTime());
    }
  else 
  {
    USB.print(F("SET RTC error. "));
    errorRTC=0;
    SumErrorRTC=SumErrorRTC+1;
    if (SumErrorRTC>10){PWR.reboot();} // si es produeixen molts errors reseteja el sistema.
    }
}
} 
/////////////////////////////////////////////////////////////////////
//////FUNCIÓ ENCARREGADA D'INICIAR ELS XBEE I OBTENIR LA MAC*////////

void IniXBee()

{
  xbeeZB.ON();
  delay(3000);
  xbeeZB.getOwnMacLow(); // obté la MAC LOW
  xbeeZB.getOwnMacHigh(); // obté la MAC HIGH
  // Guarda les MAC
  Utils.hex2str(xbeeZB.sourceMacHigh,macHigh,4); 
  Utils.hex2str(xbeeZB.sourceMacLow,macLow,4);
} 
  
////////////////////////////////////////////////////////////  
//////*COMPROVA ELS PARAMETRES DE LA XARXA XBEE*///////////  
void checkNetworkParams()
{
  // Obté la identificació de xarxa
  xbeeZB.getOperating64PAN();

  //  comprova la associació amb meshlium
  xbeeZB.getAssociationIndication();
 
  while( xbeeZB.associationIndication != 0 )
  { 
    delay(2000);
    
    
    xbeeZB.getOperating64PAN();

    USB.print(F("operating 64-b PAN ID: "));
    USB.printHex(xbeeZB.operating64PAN[0]);
    USB.printHex(xbeeZB.operating64PAN[1]);
    USB.printHex(xbeeZB.operating64PAN[2]);
    USB.printHex(xbeeZB.operating64PAN[3]);
    USB.printHex(xbeeZB.operating64PAN[4]);
    USB.printHex(xbeeZB.operating64PAN[5]);
    USB.printHex(xbeeZB.operating64PAN[6]);
    USB.printHex(xbeeZB.operating64PAN[7]);
    USB.println();     
    
    xbeeZB.getAssociationIndication();
  }

  USB.println(F("\nJoined a network!"));

  
  xbeeZB.getOperating16PAN();
  xbeeZB.getOperating64PAN();
  xbeeZB.getChannel();

  USB.print(F("operating 16-b PAN ID: "));
  USB.printHex(xbeeZB.operating16PAN[0]);
  USB.printHex(xbeeZB.operating16PAN[1]);
  USB.println();

  USB.print(F("operating 64-b PAN ID: "));
  USB.printHex(xbeeZB.operating64PAN[0]);
  USB.printHex(xbeeZB.operating64PAN[1]);
  USB.printHex(xbeeZB.operating64PAN[2]);
  USB.printHex(xbeeZB.operating64PAN[3]);
  USB.printHex(xbeeZB.operating64PAN[4]);
  USB.printHex(xbeeZB.operating64PAN[5]);
  USB.printHex(xbeeZB.operating64PAN[6]);
  USB.printHex(xbeeZB.operating64PAN[7]);
  USB.println();

  USB.print(F("channel: "));
  USB.printHex(xbeeZB.channel);
  USB.println();

}
/////////////////////////////////////////////////////////
/////////*RESETEJA ELS PAREMETRES DE LA XARXA*//////////

void  ResetNetwork(){
  
   while((xbeeZB.channel) !=0x10){
    xbeeZB.OFF();
    delay(1000);
    xbeeZB.ON();
    delay(3000);
    xbeeZB.resetNetwork(0); // reseteja els paràmetres de la xarxa
    delay(1000);
    checkNetworkParams(); // comprova aquests paràmetres.
  }
}

