////////////////////////////////////////////////////////////////////////////////////
//////CODI PROGRAMA  WASPMOTE FINESTRA///////////////////////////////////////////
////Created By Rubén Almansa for EXIT Research group//////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
#include <WaspSensorEvent_v20.h>
#include <WaspXBeeZB.h>
#include <WaspFrame.h>
#include <WaspFrameConstants.h>

///// ////// Adreça Meshlium/////////////////////
char RX_ADDRESS[] = "0013A200408134BA"; 
///////////////////////////////////////////////

/////////// DEFINICIÓ VARIABLES COMUNS///////////////
uint8_t error,error2;
char* macHigh="          ";
char* macLow="           "; 
timestamp_t time;  // guarda el timestsamp del Meshlium
unsigned long epoch; // fa un break del timestamp i ho guarda en aquesta variable
int Tx; // resgistre el flag del frame enviat.
int noSend=0; //comptador d'enviaments erronis
int errorRTC=0; //registre el flag de la RTC ok.
int SumErrorRTC=0; // comptador d'errors de la  sincronització deRTC
////////////////////////////////////////////////

////////////VARIABLES FINESTRA////////////////
float temp;
int bat;
/* El C1 c2 c3 c4 són els contactes de finestra*/
int C1;
int C2;
int C3;
float C31;
int C4;
float LDR;
float LDR2;
int PIR=0;
int ini=1;
int rebo=0;
////////////////////////////////////////////////
///////////*PROGRAMA D'INICI*///////
void setup()
{
/*ACTIVA la RTC i el port USB*/

  RTC.ON();
  delay(2000);
  USB.ON();
  delay(200);
/*S'activa la placa de sensor d'esdeveniments*/
 SensorEventv20.ON();
 delay(3000);
 //Activa les interrupcions externes
 SensorEventv20.setThreshold(SENS_SOCKET7,1);
 enableInterrupts(SENS_INT);
  
  IniXBee();   
  checkNetworkParams();
  ResetNetwork();
  RTCMeshlium();
 // Alarma que s'ativa quan esta a punt d'iniciar l'enviament
  RTC.setAlarm1("00:00:08:00",RTC_OFFSET,RTC_ALM1_MODE4); // 
  delay(1000);
}

////////////////////////////////////////
///////////*PROGRAMA PRINCIPAL*/////////

void loop()
{
  // interrupció externa
  if ((SensorEventv20.intFlag & SENS_SOCKET7))

  { 
    intFlag &= ~(SENS_INT);
    intFlag &= ~(SENS_SOCKET7);
    USB.println("detecto");
    PIR=PIR+1; // suma el trafic de persones
  } 
   // despres de l'alarma s'activa aquest if que llegeix les dades i espera les ordres d'enviar
   if(intFlag & RTC_INT)
  {
  disableInterrupts(SENS_INT);
  intFlag &= ~(RTC_INT);
  RTC.clearAlarmFlag();
  delay(1000);
  LlegirDades(); 
  while (Tx==0){
  epoch=RTC.getEpochTime();
  RTC.breakTimeAbsolute( epoch, &time);
  USB.println(RTC.getTime());
  if(((time.minute == 00) || (time.minute == 10)||(time.minute == 20)||(time.minute == 30) || (time.minute == 40)||(time.minute == 50))&&Tx==0){EnviarDades();}
  delay(5000);
 }
  Tx=0;
  ini=0;
  USB.println("enviat");
  delay(500);  
  PWR.reboot();
}   
//normalment dorm fins que arriba l'hora d'adquirir o la interrupció externa 
    enableInterrupts(SENS_INT);  
    SensorEventv20.attachInt();
    USB.println("DORMO");
    PWR.sleep(SOCKET0_OFF);
    RTC.ON();
    delay(200);
    SensorEventv20.detachInt();
    SensorEventv20.loadInt();

}
/////////////////////////////////////////////////////////
/*FUNCIÓ QUE LLEGEIX LES DADES */

void LlegirDades(){
   
 temp = SensorEventv20.readValue(SENS_SOCKET5, SENS_TEMPERATURE);
 bat=PWR.getBatteryLevel();
 LDR=SensorEventv20.readValue(SENS_SOCKET1); // esta linealitzada amb una resistència.
 delay(500);
 // equació de la linealització
 LDR2=53.125*log(LDR)+35,679;
 if(LDR2<0.5){LDR2=1;}
 C1= SensorEventv20.readValue(SENS_SOCKET2);
 C2= SensorEventv20.readValue(SENS_SOCKET3);
 //  el c31 és perquè l'entrada es analogica i llegeix el contacte de finestra
 C31= SensorEventv20.readValue(SENS_SOCKET6); 
 C4= SensorEventv20.readValue(SENS_SOCKET8);
 
 delay(100);
 
 if (C1>1){C1=1;delay(100);}else {C1=0;}
 if (C2>1){C2=1; delay(100);}else {C2=0;}
 if (C31>3.1){C3=1;delay(100);}else {C3=0;}
 if (C4>1){C4=1;delay(100); }else {C4=0;}
 
}  

/////////////////////////////////////////////////////////
///////*AQUESTA FUNCIÓ S'ENCARREGA D'ENVIAR LES DADES*///////////

void EnviarDades(){

  while(Tx==0){
   
   frame.setID( macLow ); // és el identificador del WASPMOTE
   frame.createFrame(ASCII); // indicador per iniciar el frame. 
  //s'afegeix les variables de cada waspmote que s'enviaràn
 frame.addSensor(SENSOR_STR, temp,LDR2,C1,C2,C3,C4,PIR,bat);
  delay(100);
  // envia el paquet
  error = xbeeZB.send( RX_ADDRESS, frame.buffer, frame.length );   
  if( error == 0 ) // comprova l'enviament
  
  {
    USB.println(F("send ok"));
    
    // blink green LED
    Utils.blinkGreenLED();
     noSend=0;
    Tx=1; // Variable per comfirmar qu l'envio ha estat correcte  
    delay(60000);
  }
  else 
  {
    USB.println(F("send error"));
    
     if (noSend>10){PWR.reboot();}
       noSend=noSend+1;
  }
}
}

/////////////////////////////////////////////////////////

///////* FUNCIÓ QUE CONNECTA AMB MESHLIUM PER OBTENIR EL TIMESTAMP*/////////////

void RTCMeshlium()

{
  while (errorRTC ==0){
   error2 = xbeeZB.setRTCfromMeshlium(RX_ADDRESS);
    // check flag si la RTC s'ha sincronitzat
  if( error2 == 0 )
  {
    USB.print(F("SET RTC ok. "));
    errorRTC=1;
    USB.println(RTC.getTime());
    }
  else 
  {
    USB.print(F("SET RTC error. "));
    errorRTC=0;
    SumErrorRTC=SumErrorRTC+1;
    if (SumErrorRTC>10){PWR.reboot();} // si es produeixen molts errors reseteja el sistema.
    }
}
} 
/////////////////////////////////////////////////////////////////////
//////FUNCIÓ ENCARREGADA D'INICIAR ELS XBEE I OBTENIR LA MAC*////////

void IniXBee()

{
  xbeeZB.ON();
  delay(3000);
  xbeeZB.getOwnMacLow(); // obté la MAC LOW
  xbeeZB.getOwnMacHigh(); // obté la MAC HIGH
  // Guarda les MAC
  Utils.hex2str(xbeeZB.sourceMacHigh,macHigh,4); 
  Utils.hex2str(xbeeZB.sourceMacLow,macLow,4);
} 
  
////////////////////////////////////////////////////////////  
//////*COMPROVA ELS PARAMETRES DE LA XARXA XBEE*///////////  
void checkNetworkParams()
{
  // Obté la identificació de xarxa
  xbeeZB.getOperating64PAN();

  //  comprova la associació amb meshlium
  xbeeZB.getAssociationIndication();
 
  while( xbeeZB.associationIndication != 0 )
  { 
    delay(2000);
    
    
    xbeeZB.getOperating64PAN();

    USB.print(F("operating 64-b PAN ID: "));
    USB.printHex(xbeeZB.operating64PAN[0]);
    USB.printHex(xbeeZB.operating64PAN[1]);
    USB.printHex(xbeeZB.operating64PAN[2]);
    USB.printHex(xbeeZB.operating64PAN[3]);
    USB.printHex(xbeeZB.operating64PAN[4]);
    USB.printHex(xbeeZB.operating64PAN[5]);
    USB.printHex(xbeeZB.operating64PAN[6]);
    USB.printHex(xbeeZB.operating64PAN[7]);
    USB.println();     
    
    xbeeZB.getAssociationIndication();
  }

  USB.println(F("\nJoined a network!"));

  
  xbeeZB.getOperating16PAN();
  xbeeZB.getOperating64PAN();
  xbeeZB.getChannel();

  USB.print(F("operating 16-b PAN ID: "));
  USB.printHex(xbeeZB.operating16PAN[0]);
  USB.printHex(xbeeZB.operating16PAN[1]);
  USB.println();

  USB.print(F("operating 64-b PAN ID: "));
  USB.printHex(xbeeZB.operating64PAN[0]);
  USB.printHex(xbeeZB.operating64PAN[1]);
  USB.printHex(xbeeZB.operating64PAN[2]);
  USB.printHex(xbeeZB.operating64PAN[3]);
  USB.printHex(xbeeZB.operating64PAN[4]);
  USB.printHex(xbeeZB.operating64PAN[5]);
  USB.printHex(xbeeZB.operating64PAN[6]);
  USB.printHex(xbeeZB.operating64PAN[7]);
  USB.println();

  USB.print(F("channel: "));
  USB.printHex(xbeeZB.channel);
  USB.println();

}
/////////////////////////////////////////////////////////
/////////*RESETEJA ELS PAREMETRES DE LA XARXA*//////////

void  ResetNetwork(){
  
   while((xbeeZB.channel) !=0x10){
    xbeeZB.OFF();
    delay(1000);
    xbeeZB.ON();
    delay(3000);
    xbeeZB.resetNetwork(0); // reseteja els paràmetres de la xarxa
    delay(1000);
    checkNetworkParams(); // comprova aquests paràmetres.
  }
}

