////////////////////////////////////////////////////////////////////////////////////
//////CODI PROGRAMA  WASPMOTE GASOS///////////////////////////////////////////
////Created By Rubén Almansa for EXIT Research group//////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

#include <WaspSensorGas_v20.h>
#include <WaspXBeeZB.h>
#include <WaspFrame.h>
#include <WaspFrameConstants.h>
#define GAIN  7  //GAIN del sensor C02
#define cal 3.13  // aprox 350-400ppm CO2

///// ////// Adreça Meshlium/////////////////////
char RX_ADDRESS[] = "0013A200408134BA"; 
///////////////////////////////////////////////

/////////// DEFINICIÓ VARIABLES COMUNS///////////////
uint8_t error,error2;
char* macHigh="          ";
char* macLow="           "; 
timestamp_t time;  // guarda el timestsamp del Meshlium
unsigned long epoch; // fa un break del timestamp i ho guarda en aquesta variable
int Tx; // resgistre el flag del frame enviat.
int noSend=0; //comptador d'enviaments erronis
int errorRTC=0; //registre el flag de la RTC ok.
int SumErrorRTC=0; // comptador d'errors de la  sincronització deRTC
////////////////////////////////////////////////

////////////VARIABLES GASOS////////////////
float temp;
int bat;
float CO2=0,CO20=0; // valors intermitjos de càlcul
float pressio;
float ppm; // valor final de CO2 en ppm
float CO22=0; // valor final de CO2 en volts
float tempExt; // sonda exterior
float buit=0;
int coDiv=0; // numero de dades C02 adquirides
float oPppm=0;
int tmp =0;
////////////////////////////////////////////////
///////////*PROGRAMA D'INICI*///////
void setup()
{
/*ACTIVA la RTC i el port USB*/

  RTC.ON();
  delay(2000);
  USB.ON();
  delay(200);

  SensorGasv20.ON(); // Activa la sensor board
  SensorGasv20.configureSensor(SENS_CO2, GAIN);// es configura el guany d'adquisició
  
  
  IniXBee();   
  checkNetworkParams();
  ResetNetwork();
  RTCMeshlium();
 
}

////////////////////////////////////////
///////////*PROGRAMA PRINCIPAL*/////////

void loop()
{

USB.print("agafo mesures");
LlegirDades();
LLegirCO2();

/* despres de llegir totes les dades espera que arribi el temps per enviar les dades*/
while (Tx==0){
epoch=RTC.getEpochTime();
RTC.breakTimeAbsolute( epoch, &time);
USB.println(RTC.getTime());
if(((time.minute == 00) || (time.minute == 10)||(time.minute == 20)||(time.minute == 30) || (time.minute == 40)||(time.minute == 50))&&Tx==0){EnviarDades();}
 delay(5000);

}
/*un cop envia les dades fa un repòs de 3 minuts i torna a començar el inici*/
 USB.println("a dormir");
 PWR.deepSleep("00:00:03:00",RTC_OFFSET,RTC_ALM1_MODE4,SOCKET0);
 RTC.ON();
 delay(100);
 intFlag &= ~(RTC_INT);
 RTC.clearAlarmFlag(); 
 delay(1000);
 PWR.reboot();
}


/////////FUNCIÓ QUE LLEGEIX EL C02/////////////////////

void LLegirCO2 (){
  
  USB.println("Activa CO2");
SensorGasv20.ON();
SensorGasv20.configureSensor(SENS_CO2, 7);
SensorGasv20.setSensorMode(SENS_ON, SENS_CO2);
 delay(40000);


 for(int co=0;co<420;co++){ // fa un promig promig de 3.5 minuts de dades adquirides 
 CO20= SensorGasv20.readValue(SENS_CO2);
 USB.println(CO20);
 if(CO20<3.13){
 CO2 = CO2 + CO20;
 coDiv=coDiv+1;}
 delay(500);
 }
 USB.println(coDiv);
 
 SensorGasv20.setSensorMode(SENS_OFF, SENS_CO2);
 delay(1000);
 SensorGasv20.OFF();
 delay(100);
 USB.println(tempExt);
 USB.print("acabo mesures");
 CO22=CO2/coDiv;
 // marca el slimits d'error
 if(CO22<3.00 || CO22 >3.15 || coDiv ==0){CO22=3.15;}
 USB.println(CO22); 
 oPppm=((((cal-CO22)*1000)+158.631)/62.877); // equacio logaritmica dels ppm 
 ppm=pow(10,oPppm);
 /*Marca els limits superior e inferior*/
 if (ppm>10000){ppm=10000;}
 if (ppm<350) {ppm=350;}
 }

/////////////////////////////////////////////////////////
/*FUNCIÓ QUE LLEGEIX LES DADES RESTANTS AL C02 */

void LlegirDades(){
  
 SensorGasv20.ON();
 delay(3000);
 SensorGasv20.setSensorMode(SENS_ON,SENS_TEMPERATURE);
 delay(2000); 
 temp = SensorGasv20.readValue(SENS_TEMPERATURE);
 SensorGasv20.setSensorMode(SENS_OFF,SENS_TEMPERATURE);
 delay(2000); 
 SensorGasv20.setSensorMode(SENS_ON, SENS_PRESSURE);
 delay(1000);
 pressio=SensorGasv20.readValue(SENS_PRESSURE);
 delay(500);
 SensorGasv20.setSensorMode(SENS_OFF, SENS_PRESSURE); 
 bat=PWR.getBatteryLevel();
 tempExt = Utils.readTempDS1820(DIGITAL1,TRUE); // comanda per one-wire
 if(tempExt!=-1000){Utils.writeEEPROM(1025,tempExt);}
 /* com a vegades una sola lectura dona errors, en cas d'error mes de 10 errors donarà com a respota el valor anteriror*/
 while((tempExt== -1000) && (tmp<10)){ tempExt = Utils.readTempDS1820(DIGITAL1,TRUE);tmp=tmp+1;delay(200);
 USB.println(tempExt);}
 if(tempExt==-1000){tempExt=Utils.readEEPROM(1025);}
 USB.println(tempExt);
 }

/////////////////////////////////////////////////////////
///////*AQUESTA FUNCIÓ S'ENCARREGA D'ENVIAR LES DADES*///////////

void EnviarDades(){

  while(Tx==0){
   
   frame.setID( macLow ); // és el identificador del WASPMOTE
   frame.createFrame(ASCII); // indicador per iniciar el frame. 
  //s'afegeix les variables de cada waspmote que s'enviaràn
  frame.addSensor(SENSOR_STR, temp,pressio,tempExt,CO22,ppm,bat);
  delay(100);
  // envia el paquet
  error = xbeeZB.send( RX_ADDRESS, frame.buffer, frame.length );   
  if( error == 0 ) // comprova l'enviament
  
  {
    USB.println(F("send ok"));
    
    // blink green LED
    Utils.blinkGreenLED();
     noSend=0;
    Tx=1; // Variable per comfirmar qu l'envio ha estat correcte  
    delay(60000);
  }
  else 
  {
    USB.println(F("send error"));
    
     if (noSend>10){PWR.reboot();}
       noSend=noSend+1;
  }
}
}

/////////////////////////////////////////////////////////

///////* FUNCIÓ QUE CONNECTA AMB MESHLIUM PER OBTENIR EL TIMESTAMP*/////////////

void RTCMeshlium()

{
  while (errorRTC ==0){
   error2 = xbeeZB.setRTCfromMeshlium(RX_ADDRESS);
    // check flag si la RTC s'ha sincronitzat
  if( error2 == 0 )
  {
    USB.print(F("SET RTC ok. "));
    errorRTC=1;
    USB.println(RTC.getTime());
    }
  else 
  {
    USB.print(F("SET RTC error. "));
    errorRTC=0;
    SumErrorRTC=SumErrorRTC+1;
    if (SumErrorRTC>10){PWR.reboot();} // si es produeixen molts errors reseteja el sistema.
    }
}
} 
/////////////////////////////////////////////////////////////////////
//////FUNCIÓ ENCARREGADA D'INICIAR ELS XBEE I OBTENIR LA MAC*////////

void IniXBee()

{
  xbeeZB.ON();
  delay(3000);
  xbeeZB.getOwnMacLow(); // obté la MAC LOW
  xbeeZB.getOwnMacHigh(); // obté la MAC HIGH
  // Guarda les MAC
  Utils.hex2str(xbeeZB.sourceMacHigh,macHigh,4); 
  Utils.hex2str(xbeeZB.sourceMacLow,macLow,4);
} 
  
////////////////////////////////////////////////////////////  
//////*COMPROVA ELS PARAMETRES DE LA XARXA XBEE*///////////  
void checkNetworkParams()
{
  // Obté la identificació de xarxa
  xbeeZB.getOperating64PAN();

  //  comprova la associació amb meshlium
  xbeeZB.getAssociationIndication();
 
  while( xbeeZB.associationIndication != 0 )
  { 
    delay(2000);
    
    
    xbeeZB.getOperating64PAN();

    USB.print(F("operating 64-b PAN ID: "));
    USB.printHex(xbeeZB.operating64PAN[0]);
    USB.printHex(xbeeZB.operating64PAN[1]);
    USB.printHex(xbeeZB.operating64PAN[2]);
    USB.printHex(xbeeZB.operating64PAN[3]);
    USB.printHex(xbeeZB.operating64PAN[4]);
    USB.printHex(xbeeZB.operating64PAN[5]);
    USB.printHex(xbeeZB.operating64PAN[6]);
    USB.printHex(xbeeZB.operating64PAN[7]);
    USB.println();     
    
    xbeeZB.getAssociationIndication();
  }

  USB.println(F("\nJoined a network!"));

  
  xbeeZB.getOperating16PAN();
  xbeeZB.getOperating64PAN();
  xbeeZB.getChannel();

  USB.print(F("operating 16-b PAN ID: "));
  USB.printHex(xbeeZB.operating16PAN[0]);
  USB.printHex(xbeeZB.operating16PAN[1]);
  USB.println();

  USB.print(F("operating 64-b PAN ID: "));
  USB.printHex(xbeeZB.operating64PAN[0]);
  USB.printHex(xbeeZB.operating64PAN[1]);
  USB.printHex(xbeeZB.operating64PAN[2]);
  USB.printHex(xbeeZB.operating64PAN[3]);
  USB.printHex(xbeeZB.operating64PAN[4]);
  USB.printHex(xbeeZB.operating64PAN[5]);
  USB.printHex(xbeeZB.operating64PAN[6]);
  USB.printHex(xbeeZB.operating64PAN[7]);
  USB.println();

  USB.print(F("channel: "));
  USB.printHex(xbeeZB.channel);
  USB.println();

}
/////////////////////////////////////////////////////////
/////////*RESETEJA ELS PAREMETRES DE LA XARXA*//////////

void  ResetNetwork(){
  
   while((xbeeZB.channel) !=0x10){
    xbeeZB.OFF();
    delay(1000);
    xbeeZB.ON();
    delay(3000);
    xbeeZB.resetNetwork(0); // reseteja els paràmetres de la xarxa
    delay(1000);
    checkNetworkParams(); // comprova aquests paràmetres.
  }
}

