////////////////////////////////////////////////////////////////////////////////////
//////CODI PROGRAMA  WASPMOTE SmartCities///////////////////////////////////////////
////Created By Rubén Almansa for EXIT Research group//////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

#include <WaspSensorCities.h>
#include <WaspXBeeZB.h>
#include <WaspFrame.h>
#include <WaspFrameConstants.h>

///// ////// Adreça Meshlium/////////////////////
char RX_ADDRESS[] = "0013A200408134BA"; 
///////////////////////////////////////////////

/////////// DEFINICIÓ VARIABLES COMUNS///////////////
uint8_t error,error2;
char* macHigh="          ";
char* macLow="           "; 
timestamp_t time;  // guarda el timestsamp del Meshlium
unsigned long epoch; // fa un break del timestamp i ho guarda en aquesta variable
int Tx; // resgistre el flag del frame enviat.
int noSend=0; //comptador d'enviaments erronis
int errorRTC=0; //registre el flag de la RTC ok.
int SumErrorRTC=0; // comptador d'errors de la  sincronització deRTC
////////////////////////////////////////////////

////////////VARIABLES SMART CITIES////////////////
float temp;
int bat;                       // nivell de bateria
double SorollMax,SorollMaxAct;     // variables 
float Soroll;           // Soroll en l'instant d'adquirir
float Leq=0;           // resultat final del soroll Mig
float Ldr;
double SorollAvg=0, SorollAvg1=0 ;// variables per els càlculs soroll són per fer la mitjana
int ad=0;                 // index de la taula de registres del valors de so
int b=0, c=0, ini=1,d=0;
double S[500];           // taula de registres del so
double logS; 
float loglux,Lux;       // càlcul del luxs 
////////////////////////////////////////////////
///////////*PROGRAMA D'INICI*///////
void setup()
{
/*ACTIVA la RTC i el port USB*/

  RTC.ON();
  delay(2000);
  USB.ON();
  delay(200);

  SensorCities.ON(); // Activa la sensorboard
  delay(2000); 
  
  IniXBee();   
  checkNetworkParams();
  ResetNetwork();
  RTCMeshlium();
 
}

////////////////////////////////////////
///////////*PROGRAMA PRINCIPAL*/////////

void loop()
{

 USB.println(RTC.getTime());
 LlegirSO();
 epoch=RTC.getEpochTime(); // guarda el time en un format, és necessari per la comanda següent
 RTC.breakTimeAbsolute( epoch, &time); // trenca el timestamp per obtenir el minut que estem
 
 //Aquest "if" s'encarrega de comprovar el minut d'enviament 
 if(((time.minute == 00) || (time.minute == 10)||(time.minute == 20)||(time.minute == 30) || (time.minute == 40)||(time.minute == 50))&&Tx==0){
 
  LlegirDades();
  calculdBA();
  EnviarDades();
  ad=0;
  SorollAvg=0;
  PWR.reboot();
  }
}


/////////FUNCIÓ QUE LLEGEIX EL SO/////////////////////
void LlegirSO(){
  
  // encén el sensor d'audio
  SensorCities.setSensorMode(SENS_ON, SENS_CITIES_AUDIO);
  delay(2000);
  
  // llegeix sensor d'audio
  Soroll = SensorCities.readValue(SENS_CITIES_AUDIO);
  
  // apaga el sensor d'audio
  SensorCities.setSensorMode(SENS_OFF, SENS_CITIES_AUDIO);

  USB.print(F("Sound pressure: "));
  USB.print(Soroll);
  USB.println(F("dBA"));
  S[ad]=Soroll;            // guarda els valors adquirits en una taula
  USB.println(S[ad]);
  ad=ad+1;                // incrementa l'index del valor d'audio
  
  delay(1000);
}

/////////////////////////////////////////////////////////
/*FUNCIÓ QUE LLEGEIX LES DADES RESTANTS AL SO */

void LlegirDades()
{  
  
 SensorCities.ON();
 delay(2000); 
 USB.println("llegir");
 bat=PWR.getBatteryLevel();
 SensorCities.setSensorMode(SENS_ON, SENS_CITIES_TEMPERATURE);
 delay(1500);
 temp = SensorCities.readValue(SENS_CITIES_TEMPERATURE);
 SensorCities.setSensorMode(SENS_OFF, SENS_CITIES_TEMPERATURE);
 SensorCities.setSensorMode(SENS_ON, SENS_CITIES_LDR);
 delay(1500);
 Ldr= SensorCities.readValue(SENS_CITIES_LDR);
 SensorCities.setSensorMode(SENS_OFF, SENS_CITIES_LDR);
 SensorCities.setSensorMode(SENS_ON,SENS_CITIES_HUMIDITY);
 delay(5000);
 Lux=analogRead(ANALOG7); 
 SensorCities.setSensorMode(SENS_OFF,SENS_CITIES_HUMIDITY);
 delay(100);
 Lux=(Lux*5/1024);
 loglux=pow(10,Lux); // càlcul logarítmic dels luxs
 USB.println(loglux);
  
}
/////////////////////////////////////////////////////////
///* FUNCIÓ QUE FA EL CALCUL MIG DEL SO I BUSCA EL VALOR MÀXIM *////

void calculdBA(){

 d=ad;  // 
 b=ad-1; // 
 ad =0; //
 USB.println(b);
 SorollMax=S[ad]; 
 
 /*llegim tots els registres que hem guardat a S[ad], fem la suma 
  i comprovem quin és el màxim */
 for (int e=0; e<=b;e++){
  
   if(SorollMax<S[ad]){SorollMax=S[ad];}
   SorollAvg1=pow(10,(S[ad]/10));
   USB.println (SorollAvg1);
   SorollAvg=SorollAvg1+SorollAvg;
   USB.println (SorollAvg);
   ad=ad+1;
 } 

 USB.println(d); 
 logS=(SorollAvg/d);// Promig del SO per la formula
 USB.println(logS);
 Leq=10*log10(logS); // Resultat final del SO
 USB.println(Leq);
 if(Leq<50){Leq=50;SorollMax=50;}

} 

/////////////////////////////////////////////////////////
///////*AQUESTA FUNCIÓ S'ENCARREGA D'ENVIAR LES DADES*///////////

void EnviarDades(){

  while(Tx==0){
   
   frame.setID( macLow ); // és el identificador del WASPMOTE
   frame.createFrame(ASCII); // indicador per iniciar el frame. 
  //s'afegeix les variables de cada waspmote que s'enviaràn
  frame.addSensor(SENSOR_STR, temp,Ldr,Leq,SorollMax,loglux,bat);
  delay(100);
  // envia el paquet
  error = xbeeZB.send( RX_ADDRESS, frame.buffer, frame.length );   
  if( error == 0 ) // comprova l'enviament
  
  {
    USB.println(F("send ok"));
    
    // blink green LED
    Utils.blinkGreenLED();
     noSend=0;
    Tx=1; // Variable per comfirmar qu l'envio ha estat correcte  
    delay(60000);
  }
  else 
  {
    USB.println(F("send error"));
    
     if (noSend>10){PWR.reboot();}
       noSend=noSend+1;
  }
}
}

/////////////////////////////////////////////////////////

///////* FUNCIÓ QUE CONNECTA AMB MESHLIUM PER OBTENIR EL TIMESTAMP*/////////////

void RTCMeshlium()

{
  while (errorRTC ==0){
   error2 = xbeeZB.setRTCfromMeshlium(RX_ADDRESS);
    // check flag si la RTC s'ha sincronitzat
  if( error2 == 0 )
  {
    USB.print(F("SET RTC ok. "));
    errorRTC=1;
    USB.println(RTC.getTime());
    }
  else 
  {
    USB.print(F("SET RTC error. "));
    errorRTC=0;
    SumErrorRTC=SumErrorRTC+1;
    if (SumErrorRTC>10){PWR.reboot();} // si es produeixen molts errors reseteja el sistema.
    }
}
} 
/////////////////////////////////////////////////////////////////////
//////FUNCIÓ ENCARREGADA D'INICIAR ELS XBEE I OBTENIR LA MAC*////////

void IniXBee()

{
  xbeeZB.ON();
  delay(3000);
  xbeeZB.getOwnMacLow(); // obté la MAC LOW
  xbeeZB.getOwnMacHigh(); // obté la MAC HIGH
  // Guarda les MAC
  Utils.hex2str(xbeeZB.sourceMacHigh,macHigh,4); 
  Utils.hex2str(xbeeZB.sourceMacLow,macLow,4);
} 
  
////////////////////////////////////////////////////////////  
//////*COMPROVA ELS PARAMETRES DE LA XARXA XBEE*///////////  
void checkNetworkParams()
{
  // Obté la identificació de xarxa
  xbeeZB.getOperating64PAN();

  //  comprova la associació amb meshlium
  xbeeZB.getAssociationIndication();
 
  while( xbeeZB.associationIndication != 0 )
  { 
    delay(2000);
    
    
    xbeeZB.getOperating64PAN();

    USB.print(F("operating 64-b PAN ID: "));
    USB.printHex(xbeeZB.operating64PAN[0]);
    USB.printHex(xbeeZB.operating64PAN[1]);
    USB.printHex(xbeeZB.operating64PAN[2]);
    USB.printHex(xbeeZB.operating64PAN[3]);
    USB.printHex(xbeeZB.operating64PAN[4]);
    USB.printHex(xbeeZB.operating64PAN[5]);
    USB.printHex(xbeeZB.operating64PAN[6]);
    USB.printHex(xbeeZB.operating64PAN[7]);
    USB.println();     
    
    xbeeZB.getAssociationIndication();
  }

  USB.println(F("\nJoined a network!"));

  
  xbeeZB.getOperating16PAN();
  xbeeZB.getOperating64PAN();
  xbeeZB.getChannel();

  USB.print(F("operating 16-b PAN ID: "));
  USB.printHex(xbeeZB.operating16PAN[0]);
  USB.printHex(xbeeZB.operating16PAN[1]);
  USB.println();

  USB.print(F("operating 64-b PAN ID: "));
  USB.printHex(xbeeZB.operating64PAN[0]);
  USB.printHex(xbeeZB.operating64PAN[1]);
  USB.printHex(xbeeZB.operating64PAN[2]);
  USB.printHex(xbeeZB.operating64PAN[3]);
  USB.printHex(xbeeZB.operating64PAN[4]);
  USB.printHex(xbeeZB.operating64PAN[5]);
  USB.printHex(xbeeZB.operating64PAN[6]);
  USB.printHex(xbeeZB.operating64PAN[7]);
  USB.println();

  USB.print(F("channel: "));
  USB.printHex(xbeeZB.channel);
  USB.println();

}
/////////////////////////////////////////////////////////
/////////*RESETEJA ELS PAREMETRES DE LA XARXA*//////////

void  ResetNetwork(){
  
   while((xbeeZB.channel) !=0x10){
    xbeeZB.OFF();
    delay(1000);
    xbeeZB.ON();
    delay(3000);
    xbeeZB.resetNetwork(0); // reseteja els paràmetres de la xarxa
    delay(1000);
    checkNetworkParams(); // comprova aquests paràmetres.
  }
}

